using System;
using System.Windows.Forms;
using System.Collections.Generic;
using System.Text;
using System.Runtime.InteropServices;
using System.Runtime.InteropServices.ComTypes;
using System.IO;

[assembly: ClassInterface(ClassInterfaceType.AutoDual)]
namespace NavisionSteamTest
{
    [Guid("9BEBC5EF-CB79-45d2-9C68-84F2B9A990C8")]
    [InterfaceTypeAttribute(ComInterfaceType.InterfaceIsIDispatch)]
    public interface INaviSreamObject
    {
        [DispIdAttribute(2)]
        bool LoadFromNavision([In, MarshalAs(UnmanagedType.AsAny)] object COMStream, string fileName);

		[DispIdAttribute(3)]
		bool SendToNavision([Out, MarshalAs(UnmanagedType.AsAny)] object COMStream, string fileName);

        [DispIdAttribute(1)]
        void Test(string message);
    }

    [ProgId("NavisionSteamTest")]
    [ClassInterface(ClassInterfaceType.None)]
    public class NaviSreamObject: INaviSreamObject
    {
        IntPtr rwBytes = IntPtr.Zero;

        public void Test(string message)
        {
            MessageBox.Show(message);
        }

		public bool LoadFromNavision([In, MarshalAs(UnmanagedType.AsAny)] object COMStream, string fileName)
		{
			bool flag1 = true;
			Stream stream1 = new MemoryStream();
			byte[] buffer1 = new byte[0xafc8];
			this.rwBytes = Marshal.AllocHGlobal(4);
			IStream COMStream1 = COMStream as IStream;
			FileStream writer = new FileStream(fileName, FileMode.CreateNew);
			int _rwBytes = 0;

			do
			{
				COMStream1.Read(buffer1, 0xafc8, this.rwBytes);
				_rwBytes = Marshal.ReadInt32(this.rwBytes);
				writer.Write(buffer1, 0, _rwBytes);
			}
			while (_rwBytes > 0);
			Marshal.FreeHGlobal(this.rwBytes);
			writer.Close();
			writer.Dispose();
			return flag1;
		}

		public bool SendToNavision([Out, MarshalAs(UnmanagedType.AsAny)] object COMStream, string fileName)
		{
			IStream COMStream1 = COMStream as IStream;
			this.rwBytes = Marshal.AllocHGlobal(4);
			int bytes = 0;
			byte[] buffer1 = new byte[0xafc8];
			FileStream reader = new FileStream(fileName, FileMode.Open);
			//IStream COMStream = new IStream();
			int _rwBytes = 0xafc8;
			bool result = true;
			int bytesRead = 0;
			do
			{
				bytesRead = reader.Read(buffer1, 0, _rwBytes);
				Marshal.WriteInt32(this.rwBytes, bytesRead);
				COMStream1.Write(buffer1, bytesRead, this.rwBytes);
			}
			while (bytesRead > 0);
			//COMStream1.Commit(0);
			reader.Close();
			reader.Dispose();
			Marshal.FreeHGlobal(this.rwBytes);
			return result;
		}
    }
}
